/*******************************************************************************
Copyright © 2023 Sebastian Roith

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*******************************************************************************/

window.TASK = function(fktRandomInt) {
    function getUniqueValues(count, min, max) {
        const values = [];
        while (values.length < count) {
            const randomValue = fktRandomInt(min, max - values.length);
            values.push(values.slice().sort((a, b) => a - b).reduce((newValue, oldValue) => ((newValue >= oldValue) ? (newValue + 1) : newValue), randomValue));
        }
        return values;
    }

    const result = {
        task: 'Führe den Code aus, indem du immer die Auswirkungen der hervorgehobenen Zeile in der Speichertabelle einträgst und die nächste auszuführende Codezeile auswählst.',
        code: '',
        steps: [
            { line: -1, vars: [], task: '<p>Überlege zuerst: Was müsste das Programm insgesamt bewirken?</p><p>Trage nichts in die Speichertabelle ein und wähle die allererste Anweisung aus, um mit der schrittweisen Ausführung zu beginnen. So kannst du deine Vermutung überprüfen.</p>' }
        ]
    }

    const varType = 'int';
    const varNames = getUniqueValues(2, 'a'.charCodeAt(0), 'z'.charCodeAt(0)).map(code => String.fromCharCode(code));
    const varValues = getUniqueValues(2, 0, 9);
    const overrideIndex = fktRandomInt(0, 1);
    const finalValue = varValues[1 - overrideIndex];

    result.steps.push({
        task: result.task,
        line: 0
    });

    result.code = varType + ' ' + varNames[0] + ' = ' + varValues[0] + ';';
    result.steps.push({
        line: (result.code.match(/\n/g) || []).length + 1,
        vars: [ { key: varNames[0], value: varValues[0], type: varType } ]
    });

    result.code += '\n' + varType + ' ' + varNames[1] + ' = ' + varValues[1] + ';';
    result.steps.push({
        line: (result.code.match(/\n/g) || []).length + 1,
        vars: [ { key: varNames[0], value: varValues[0], type: varType }, { key: varNames[1], value: varValues[1], type: varType } ]
    });

    result.code += '\n' + varNames[overrideIndex] + ' = ' + varNames[1 - overrideIndex] + ';';
    result.steps.push({
        line: (result.code.match(/\n/g) || []).length + 1,
        vars: [ { key: varNames[0], value: finalValue, type: varType }, { key: varNames[1], value: finalValue, type: varType } ]
    });

    result.code += '\n' + varNames[1 - overrideIndex] + ' = ' + varNames[overrideIndex] + ';';
    result.steps.push({
        line: (result.code.match(/\n/g) || []).length + 1,
        vars: [ { key: varNames[0], value: finalValue, type: varType }, { key: varNames[1], value: finalValue, type: varType } ]
    });

    result.steps[result.steps.length - 1].line = Infinity;
    result.steps[result.steps.length - 1].task = '<p>Ist dir nun klar, warum das Programm <strong>nicht</strong> dazu führt, dass die beiden Variablen ihre Werte tauschen?</p><p>Denke nochmal darüber nach und klicke erst dann erneut auf „Fertig“!</p>';
    result.steps.push({ line: Infinity });
    return result;
};
